#!/bin/sh
# zzz_prefer.sh v1.0  (c) 29.11.2019 by Andreas Ley  (u) 8.9.2020
# For a login shell, include user's preferences and execute the preferred shell

# This script has an unusual name to ensure it will run last, as it supersedes the current shell
# Since LC_COLLATE can be set from e.g. sshd, we have to use a char that sorts last in the most common locales, and this is 'Z' and not ASCII-last '~'

export REMOTEUSER
eval $(prefer -l)

# Is there a use case where this could run on a non-terminal?
if test -t 0 -a -n "${PREFER_SHELL}" -a "${SHELL}" != "${PREFER_SHELL}" -a -x "${PREFER_SHELL}"; then
	# Unfortunatly, this does not work with zsh on a real tty
	# It loops with read(0, NULL, 0) = -1 EIO (Input/output error)
	if test "${SHELL}" = "/bin/sh"; then
		SHELL="${PREFER_SHELL}"; export SHELL
		exec ${SHELL} ${PREFER_SHELL_OPTIONS}
	else
		SHELL="${PREFER_SHELL}"; export SHELL
		exec -l "${SHELL}"
	fi
fi
unset PREFER_SHELL PREFER_SHELL_OPTIONS
